clear 
clear

load('acc_signal_s_dioptres.mat')
n=1000;

   %% 
for dist=1:2

    
freq=linspace(0.1,50,50);
MSD_m=zeros(8*4*8000/n,n);
ACI_m=zeros(8*4*8000/n,n);
F_m=zeros(8*4*8000/n,length(freq));
rms2=zeros(8*4*8000/n,1);%rms^2 sur un interval

if dist==1%near
    col='k';

else%far
    col='g';
end



nn=0;
for i=1:32%trial*subject
    x=signal{i,dist}';
    
    
    L=1;
    for j=1:(8000/n)%interval
     xx=x(L:L+n-1);
     nn=nn+1;
     liste=find(isfinite(xx));
     
     t=(liste-1)/173;
     F_m(nn,:) = (psd_lomb(t,xx(liste),freq))';
     dx=x(L+1:L+n-1)-x(L:L+n-2);
        dx=[0 dx];%rajoute un lment.
       DX(nn,:,dist)=dx;

     
        
     for m=0:n-1
         count=0;
         count2=0;
          
         for ii=1:n-m
             
        
             if isfinite(xx(ii+m)-xx(ii))
             MSD_m(nn,m+1)= MSD_m(nn,m+1)+(xx(ii+m)-xx(ii))^2; 
            count=count+1;
             
             end
              if isfinite(dx(ii+m)-dx(ii))
             ACI_m(nn,m+1)=ACI_m(nn,m+1)+dx(ii+m)*dx(ii);
              count2=count2+1;
             end
             
             
         end
        
        MSD_m(nn,m+1)= MSD_m(nn,m+1)/count;
        ACI_m(nn,m+1)= ACI_m(nn,m+1)/count2;
     end
   
      
         L=L+n;
    end
end
figure(1)
subplot(1,3,1)
hold on
C=mean(173^2*ACI_m(:,1:end),'omitnan');
S=std(173^2*ACI_m(:,1:end),[],'omitnan');
T=(0:n-1)/173;
C=[C(end:-1:2) C];
T=[-T(end:-1:2) T];
S=[S(end:-1:2) S];
H1(dist)=plot(T,C,col);
inBetween = [C+S, fliplr(C-S)];
fill([T, fliplr(T)], inBetween,col,'EdgeAlpha',0,'FaceAlpha',0.1);
xlim([-2 2])
box on


if dist==2
legend(H1,'Near','Far','fontsize',12)
end
set(gca,'fontsize',10)
title('(a)','fontweight','normal','fontsize',12)
xlabel('Time lag (s)','fontsize',12)
ylabel('ACI/\deltat^2 (D^2/s^2)','fontsize',12)



subplot(1,3,2)
hold on
C=mean(173^2*ACI_m(:,2:end),'omitnan');
S=std(173^2*ACI_m(:,2:end),[],'omitnan');
T=(1:n-1)/173;
H3(dist)=plot(T,C,col);
inBetween = [C+S, fliplr(C-S)];
fill([T, fliplr(T)], inBetween,col,'EdgeAlpha',0,'FaceAlpha',0.1);
xlim([-0.01 0.5])
box on


if dist==2
legend(H3,'Near','Far','fontsize',12)
end
set(gca,'fontsize',10)
title('(b)','fontweight','normal','fontsize',12)







figure(1)
subplot(1,3,3)
hold on;
r=mean(MSD_m(:,1:end),'omitnan');
s=std((MSD_m(:,1:end)),[],'omitnan');
H2(dist)=plot((0:n-1)/173,r,col);
inBetween = [r+s, fliplr(r-s)];
fill([((0:n-1)/173), fliplr(((0:n-1)/173))], inBetween,col,'EdgeAlpha',0,'FaceAlpha',0.1);
if dist==1
 plot((0:n-1)/173,0.038+0.003628*(0:n-1)/173,'--k')
else
plot((0:n-1)/173,+0.003628*(0:n-1)/173,'--g');
xlim([0 6]);box on;
legend(H2,'Near','Far','fontsize',12)
end
set(gca,'fontsize',10)
title('(c)','fontweight','normal','fontsize',12)
xlabel('Time lag (s)','fontsize',12)
ylabel('MSD (D^2)','fontsize',12)
 

figure(2)
subplot(1,2,dist)
hold on;
t=(0:n-2)/173;
r=173*(mean(MSD_m(:,2:end),'omitnan')-mean(MSD_m(:,1:end-1),'omitnan'));
C=173*(mean(ACI_m,'omitnan'));
C=[C(end:-1:2) C];
for k=0:n-2
R(k+1)=sum(C(n-k:n+k));
end
plot(t,r,'g');
plot(t,R,'-.k');
plot(t,0.0036*ones(size(t)),'--r')

xlim([0 2]);
box on
legend('\deltaMSD/\deltat','\SigmaACI/\deltat','fontsize',12)
set(gca,'fontsize',10)

if dist==1
ylim([-0 0.15])
title('(a)','fontweight','normal','fontsize',12)
xlabel('Time lag (s)','fontsize',12)
ylabel('Increase rate of MSD (D^2/s)','fontsize',12)
else
ylim([-0 0.15])
title('(b)','fontweight','normal','fontsize',12)
end
%mean(LL)

%%
[MSD_s,ACI_s,F_s,x]=Model(mean(ACI_m,'omitnan'),n,freq,1e4);
%%

figure(3)


subplot(2,3,1+(dist-1)*3)
hold on
if dist==1
plot((0:n-1)/173,signal{2,1}(1:n),'k');
else
plot((0:n-1)/173,signal{2,2}(1:n),'k');  
end

plot((0:n-1)/173,x,'g');
box on;
legend('Measurement','Simulation','fontsize',12);
set(gca,'fontsize',10)
xlabel('Time (s)','fontsize',12)
ylabel({'Accommodative';'signal (D)'},'fontsize',12)
title('(a)','fontweight','normal','fontsize',12)
if dist==2
title('(d)','fontweight','normal','fontsize',12)
end

subplot(2,3,2+(dist-1)*3)
hold on
r=mean(MSD_m(:,1:end),'omitnan');
s=std((MSD_m(:,1:end)),[],'omitnan');
plot((0:n-1)/173,r,'k');
inBetween = [r+s, fliplr(r-s)];
fill([((0:n-1)/173), fliplr(((0:n-1)/173))], inBetween,'k','EdgeAlpha',0,'FaceAlpha',0.1);
r=mean(MSD_s(:,1:end),'omitnan');
s=std((MSD_s(:,1:end)),[],'omitnan');
plot((0:n-1)/173,r,'g');
inBetween = [r+s, fliplr(r-s)];
fill([((0:n-1)/173), fliplr(((0:n-1)/173))], inBetween,'g','EdgeAlpha',0,'FaceAlpha',0.1);
xlim([0 6])
box on;
set(gca,'fontsize',10)
xlabel('Time lag (s)','fontsize',12)
ylabel('MSD (D^2)','fontsize',12)
title('(b)','fontweight','normal','fontsize',12)
if dist==2
title('(e)','fontweight','normal','fontsize',12)
end

subplot(2,3,3+(dist-1)*3)
hold on
r=mean((F_m),'omitnan');
s=std(log10(F_m),[],'omitnan');
plot(freq,r,'k');
inBetween = [10.^(log10(r)+s), fliplr(10.^(log10(r)-s))];
fill([freq, fliplr(freq)], inBetween,'k','EdgeAlpha',0,'FaceAlpha',0.1);
r_s=mean((F_s),'omitnan');
s_s=std(log10(F_s),[],'omitnan');
plot(freq,r_s,'g');hold on
inBetween = [10.^(log10(r_s)+s_s), fliplr(10.^(log10(r_s)-s_s))];
fill([freq, fliplr(freq)], inBetween,'g','EdgeAlpha',0,'FaceAlpha',0.1);


set(gca,'xscale','log')
set(gca,'yscale','log')
xlim([0.05 100])
box on
set(gca,'fontsize',10)
xlabel('Frequency (Hz)','fontsize',12)
ylabel('PSD (D^2/Hz)','fontsize',12)
title('(c)','fontweight','normal','fontsize',12)
if dist==2
title('(f)','fontweight','normal','fontsize',12)
end

end






